VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'---------------------------------------------------------------------------------------------------------------------------------------
'
'  Sample
'
'  eMedia plug-in
'
'---------------------------------------------------------------------------------------------------------------------------------------
'
' Purpose ...... This COM component will display a message for every operation done by the user.
' Author ....... Mediasoft Technologies
' Date ......... April 4, 2001 - modified december 12, 2002 - modified november 21, 2005
'
'---------------------------------------------------------------------------------------------------------------------------------------
'
' Handling errors:
'   eMedia handles errors from the Plug-In, and doesn't crash if the plug-in raise an error.
'   But eMedia doesn't display any message if the plug-in fires an error. You must handle
'   yourself your own errors.
'
' Functions:
'
'   Active
'     Set this property to True to receive the calls to the functions EPI_Job...
'
'   EPI_Initialize(String)
'     This method is called when eMedia needs the Plug-In to initialize itself
'     (when eMedia starts or when the user selects this plug-in). The constuctor
'     of the class can also be coded.
'     The parameter contains the language (English, Franais, Deutsch, Espaol,
'     Portugues, Italiano, etc)
'     The function must return True if everything is Ok, then the plug-in will be used.
'     If the function returns False, the plug-in will not be called anymore.
'
'   EPI_GetCardObject(object)
'     This method is called just after the call to EPI_Initialize, and provides
'     an eMedia.CardObjects object in the argument. This object can be used by
'     your plug-in to request information from eMedia. Please refer to the
'     CardObjects class members documentation for more information.
'
'   EPI_Terminate()
'     This method is called when eMedia needs the Plug-In to terminate function
'     (When eMedia is closed or when the user deactivate this plug-in). The
'     destructor of the class can also be coded.
'
'   EPI_Preferences(Form)
'     This method is called by eMedia when the user selects in the "Plug-In" menu
'     the name of the plug-in. You can configure it there, display a dialog, and
'     so on. The parameter contains the instance of the main application form.
'
'   EPI_Supports(enumPlugInOperations)
'     Called before EPI_Job to know the Plug-In capabilities. This method must return
'     True or False, depending on the operations that the plug-in manages. If the method
'     doesn't exist, then eMedia will consider that the Plug-In supports all operations.
'
'   EPI_SetMode(enumPlugInModes)
'     Called when the user goes to creation or exploitation mode. The parameter value
'     reflects the new mode of utilization.
'
'   EPI_Job(enumPlugInOperations)
'     Called first for each record added / modified / deleted, when the card is
'     printed, when an image acquisition is done and when CoolReader find a record.
'     Called again at the end of the operation for information. The parameter tells
'     you what is the operation.
'     The call to this method is followed by one call to EPI_Database, then by zero,
'     one or more calls to EPI_DataTransmit, then by one call to EPI_Job(PlugInEnd).
'
'   EPI_Database(ADODB.Recordset)
'     Called just after EPI_Job. The parameter IS the ADODB Recordset object used
'     by eMedia. So, use it very carefully to avoid problems. The current record
'     in this recordset is the one used by eMedia. If you plan to use this object,
'     clone it before with the .clone method, use the cloned recordset, then delete it.
'
'   EPI_DataTransmit(enumPlugInDataSource, String, Variant, Long)
'     Called for each field of the record/card. The first parameter always contains the
'     type of the value name. The second parameter contains the object/field name,
'     the third parameter contains the object/field value, the fourth parameter contains
'     the length of the data.
'
'---------------------------------------------------------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------------------------------------------------------
' public enumerations
'---------------------------------------------------------------------------------------------------------------------------------------

'Current job information, for EPI_Job
Public Enum enumPlugInOperations
  PlugInEnd = 0
  PlugInDBAdd = 1
  PlugInDBModify = 2
  PlugInDBDelete = 3
  PlugInPrint = 4
  PlugInAcquire = 5
  PlugInCoolReader = 6
  PlugInCardOpen = 7
  PlugInCardSave = 8
  PlugInCardNew = 9
End Enum

'Source of data, for EPI_DataTransmit
Public Enum enumPlugInDataSource
  PlugInDBField = &H1
  PlugInDBRecordNo = &H2
  PlugInCardObject = &H4
  PlugInFrontSide = &H8
  PlugInBackSide = &H10
  PlugInSmartCard = &H20
  PlugInMagneticStrip1 = &H40
  PlugInMagneticStrip2 = &H80
  PlugInMagneticStrip3 = &H100
  PlugInContactLess = &H200
  PlugInStartEncoding = &H400
  PlugInStartPrinting = &H800
  PlugInCardInfo = &H1000
End Enum

'For eMedia utilization mode, for EPI_SetMode
Public Enum enumPlugInModes
  PlugInDesign = 0
  PlugInOperation = 1
End Enum

'For eMedia database links
Public Enum enumDBEngine
  engNone = -1
  engAccess95 = 0
  engSQLServer = 1
  engOracle = 2
  engODBC = 3
  engAccess2000 = 4
  engExcel = 5
  engOLEDB = 6
End Enum

'---------------------------------------------------------------------------------------------------------------------------------------
' Internal data
'---------------------------------------------------------------------------------------------------------------------------------------

Private m_Operation As String
Private m_Active As Boolean
Private m_Recordset As ADODB.Recordset
Private m_eMediaObject As Object
Dim ObjCom As Object

'---------------------------------------------------------------------------------------------------------------------------------------
' Appel  la dll Delphi ou C#
'---------------------------------------------------------------------------------------------------------------------------------------
'Private Declare Function COD_GetActive Lib "codeand.dll" () As Boolean
'Private Declare Sub COD_SetActive Lib "codeand.dll" (ByVal vActive As Boolean)
'Private Declare Function COD_Initialize Lib "codeand.dll" (ByVal CurrentLanguage As String) As Boolean
'Private Declare Sub COD_GetCardObject Lib "codeand.dll" (TheObject As Object)
'Private Declare Sub COD_Terminate Lib "codeand.dll" ()
'Private Declare Sub COD_Preferences Lib "codeand.dll" (AppForm As Object)
'Private Declare Function COD_Supports Lib "codeand.dll" (ByVal lngFunctionality As enumPlugInOperations) As Boolean
'Private Declare Sub COD_SetMode Lib "codeand.dll" (ByVal lngNewMode As enumPlugInModes)
'Private Declare Sub COD_Job Lib "codeand.dll" (ByVal op As enumPlugInOperations)
'Private Declare Sub COD_Database Lib "codeand.dll" (ByVal rsData As ADODB.Recordset, ByVal lngDatabaseEngine As enumDBEngine)
'Private Declare Sub COD_DataTransmit Lib "codeand.dll" (ByVal parmSource As enumPlugInDataSource, _
                                                                                     ByVal parmName As String, _
                                                                                     ByVal parmValue As Variant, _
                                                                                     ByVal parmSize As Long)
                                                                                     
Private Function OK(ByVal obj As Object) As Boolean
   If (IsObject(obj) = False) Then
    If (obj Is Nothing) Then
      OK = True
    Else
      MsgBox "Object null"
      OK = False
    End If
  Else
    MsgBox "Ce n'est pas un objet"
    OK = False
  End If
End Function


'---------------------------------------------------------------------------------------------------------------------------------------
' Active Property: TRUE if the Plug-In is used
'---------------------------------------------------------------------------------------------------------------------------------------

Public Property Let Active(ByVal vActive As Boolean)
  'If OK(ObjCom) = True Then
  'ObjCom.COD_SetActive (vActive)
  'End If
End Property

Public Property Get Active() As Boolean
  'If OK(ObjCom) = True Then
  'Active = ObjCom.COD_GetActive()
  Active = True
  'End If
End Property

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called for initialization
'---------------------------------------------------------------------------------------------------------------------------------------

Public Function EPI_Initialize(ByVal CurrentLanguage As String) As Boolean
Attribute EPI_Initialize.VB_Description = "Method called at initialization time."
   MsgBox "V Initialise"
   Set ObjCom = CreateObject("Codeand.Plugin")
   EPI_Initialize = ObjCom.COD_Initialize(CurrentLanguage)
End Function

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called to provide a callback object
'---------------------------------------------------------------------------------------------------------------------------------------

Public Sub EPI_GetCardObject(TheObject As Object)
   MsgBox "V GetCardObject"
   ObjCom.COD_GetCardObject (TheObject)
End Sub

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called for termination
'---------------------------------------------------------------------------------------------------------------------------------------

Public Sub EPI_Terminate()
Attribute EPI_Terminate.VB_Description = "Method called at termination time."
   MsgBox "V Terminate"
   ObjCom.COD_Terminate
   Set ObjCom = Nothing
End Sub

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called for configuration
'---------------------------------------------------------------------------------------------------------------------------------------
Public Sub EPI_Preferences(AppForm As Object)
Attribute EPI_Preferences.VB_Description = "Method called for user preferences."
   MsgBox "V Preference"
   ObjCom.COD_Preferences
End Sub

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called to check the plug-in capabilities
'---------------------------------------------------------------------------------------------------------------------------------------
Public Function EPI_Supports(ByVal lngFunctionality As enumPlugInOperations) As Boolean
  MsgBox "V Supports"
  EPI_Supports = ObjCom.COD_Supports(lngFunctionality)
  'EPI_Supports = True
End Function

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called when the user go to the exploitation or creation mode
'---------------------------------------------------------------------------------------------------------------------------------------
Public Sub EPI_SetMode(ByVal lngNewMode As enumPlugInModes)
  ObjCom.COD_SetMode (lngNewMode)
End Sub

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called at the beginning and at the end of every operation
'---------------------------------------------------------------------------------------------------------------------------------------
' Note: The parameter contains the operation that eMedia is performing
Public Sub EPI_Job(ByVal op As enumPlugInOperations)
  ObjCom.COD_Job (op)
End Sub

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called to provide the current recordset
'---------------------------------------------------------------------------------------------------------------------------------------
Public Sub EPI_Database(ByVal rsData As ADODB.Recordset, ByVal lngDatabaseEngine As enumDBEngine)
  'COD_Database(rsData, lngDatabaseEngine)
End Sub

'---------------------------------------------------------------------------------------------------------------------------------------
' This function is called to provide card objects and values, or database field names and values
'--------------------------------------------------------------------------------------------------------------------------------------
Public Sub EPI_DataTransmit(ByVal parmSource As enumPlugInDataSource, _
                            ByVal parmName As String, _
                            ByVal parmValue As Variant, _
                            ByVal parmSize As Long)
  'COD_DataTransmit(parmSource, parmName, parmValue, parmSize)
End Sub
'EOF
